clear
% parameters
A=1;
B=1;
n=0.01;
tauy=0.2;
tauc=0.1;
delta=0.1;
alpha=0.36;
sigma=1.5;
beta=0.95;
%%%%%%%%%%%%%
%steady state
zss=A;
gss=((beta/(1+n))*((1-tauy)*A+1-delta))^(1/sigma);
xss=(1/(1+tauc))*((1-tauy)*A+1-delta-(1+n)*gss);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nobs=300;
rho=0.95;
sigmae=0.0;
paramet=[A,B,beta,sigma,n,delta,alpha,tauc,tauy,rho,sigmae,nobs];


    % innovation

        aleatn = normrnd(0,1,nobs+200,1);
        eps = sigmae*aleatn(201:length(aleatn))';
    %%%%%%%%%%%%
    
    V=simulats(paramet,eps);

   
    
    lc=V(:,1);
    lk=V(:,2);
    ly=V(:,3);
    
    z3=exp(ly-lk);
    x3=exp(lc-lk);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%
z=[];x=[];
param=[A,B,n,tauy,tauc,delta,alpha,sigma,beta];
xt0=xss;


t=nobs-1;
for i=1:t
    zt=(i-1)*(z3(1)*1.4/(nobs-2));
    z=[z;zt];
    xt=fsolve('dx0',xt0,optimset,param,zt);
    x=[x;xt];
    xt0=xt;
end

z1=((1+tauc).*x+delta+n)./(1-tauy);
z2=A.*ones(t,1);



x2=xss.*ones(t,1);

x4=[]; z4=z3(1).*ones(nobs-1,1);
z5=[]; x5=x3(1).*ones(nobs-1,1);z6=[];
for i=1:nobs-1
    x4i=x3(1)-(i-1)*((x3(1)-x(1))/(nobs-2));
    x4=[x4;x4i];
    z5i=z3(1)-(i-1)*((z3(1)-z1(1))/(nobs-2));
    z5=[z5;z5i];
    z6i=zss-(i-1)*((zss-z1(1))/(nobs-2));
    z6=[z6;z6i];
    
end

xx=x*ones(1,299);
zz=(z1(1):(zss-z1(1))/298:zss);

plot(zz,xx','y.',z,x,'k',z1,x,'b',z2,x,'b',z6,x2,'k-.',z3,x3,'r',z3,x3,'k<',z4,x4,'r-.',z5,x5,'r-.');
axis('tight');
text(max(z2),max(x)*0.95,'z_{t+1}=z_t');
text(max(z1),max(x)*0.95,'z_{t+1}=z_t');
text(max(z)*0.9,max(x)*0.85,'x_{t+1}=x_t');
text(min(z1)*2,max(x2),'x_{ss}');
text(min(z2),min(x)*1.5,'z_{ss}');
text(min(z4),min(x)*1.5,'z_0');
text(min(z1)*2,min(x5),'x_0');
text(max(z),min(x)*1.5,'z');
text(min(z1)*2,max(x),'x');
text(max(z4)*1.05,max(x5),'transitional dynamics');
title('The phase diagram for Jones&Manuelli model');
